<?php

namespace DataView;

class ProtokollVorlage {
  
  

  
  

    // --- Statische Methoden ---
  
  public static function renderScript() { 
    
    
    // --- BLOCK: main ---
    
								\FOP\I18n::ensureIsLoaded();
								?>
								<script type="text/javascript">
									
									
									function updateNumberprotokollVorlage(col) {
										//var checklist = window.DataViewChecked['protokollVorlage'][col];
										//if (checklist.id) {
											// checklist is online
											// TODO: check if cache is alive, otherwise reload from ajax, delay execution and return now
											//checklist.ranges = [[1,10000000]]; // mostly we use indirect idlists to tick all marks; so this is an approximation
										//}
										// checkboxes aktualisieren
										if (window.DataViewChecked && window.DataViewChecked['protokollVorlage'] && window.DataViewChecked['protokollVorlage'][col].ranges.length > 0) {
											$('.protokollVorlage__mass-action').css('visibility', 'visible');
											$('.protokollVorlage__action').css('visibility', 'hidden');
										} else {
											$('.protokollVorlage__mass-action').css('visibility', 'hidden');
											$('.protokollVorlage__action').css('visibility', 'visible');
										}
										$('.protokollVorlage__checkbox').each(function (idx, x) {
											for (var cssclass of x.classList) {
												if (cssclass.startsWith('protokollVorlage__checkbox-'+col+'-')) {
													var my_id = cssclass.substr(('protokollVorlage__checkbox-'+col+'-').length);
													if (window.DataViewChecked) {
														x.MaterialCheckbox[checklist.has(my_id) ? 'check' : 'uncheck']();
													}
												}
											}
										});
									}
									function reloadprotokollVorlage (params, returnUrl, onlyScroll, addPadding = 0) {
										// copy query
										let nq = JSON.parse(JSON.stringify(query));
										nq['parent_request'] = <?php echo json_encode(strtok(\FOP\Util::getBackUrl(), '?')); ?>;
										<?php if (isset($_GET['select'])) { ?>nq['select'] = 'select';<?php } ?>
										
										if (params) {
											for (var i in params) nq[i] = params[i];
											var action = nq['action'];
											delete nq['action'];
											let querystr = "DataView/ProtokollVorlage/" + action + "?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// direkt aufrufen (ist wohl ein Download oder so)
											if (returnUrl) return querystr;
											window.location.href = querystr;
										} else {
											let querystr;
											
											
											<?php if ((!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest())) { ?>
											delete nq['action'];
											querystr = "DataView/ProtokollVorlage/renderTabTable?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// per Ajax laden
											if(!$("#protokollVorlage-table")?.parent()?.parent()?.hasClass('fop-form-feature-collapsed') || $("#protokollVorlage-table")?.parent()?.parent()?.hasClass('fop-form-feature-mode-area')) {
											$.get(querystr, function(data){
												var tab = $("#protokollVorlage-table");
												var top = tab.find('.fop-table-body-inner');
												var el;
												if (onlyScroll && (el = $('<div class="tabcontent">' + data + '</div>').find('.fop-table-body-inner'))) {
													// nur Scroll-Bereich ersetzen
													var paddingTop = parseInt(el.css('paddingTop') || '0px', 10);
													var minHeight = parseInt(el.css('minHeight'), 10)
													paddingTop += addPadding;
													minHeight += addPadding;
													top.css({paddingTop: paddingTop.toString()+'px', minHeight: minHeight.toString()+'px'}); // Offset
													el = el.children();
													top.empty();
													top.append(el);
													el = top; // top-upgrade doppelt machen, dadurch vermeiden wir das Array-upgrade => Performance
												} else {
													// gesamten Tab ersetzen
													tab.children().remove();
													el = tab.html('<div class="tabcontent">' + data + '</div>');
												}
												try {
													for (var i = 0; i < el.length; i++) upgradeDOM(el[i]);
												} catch (e) {
													console.log(e);
												}
												upgradeTable(el.find('.fop-table .fop-table-header')); // Falls es Tabellen-Layout ist: Spalten-Order anpassen
												flushURL(); // Neue URL in Titelleiste eintragen

												// Checkbox-Auswahl ankreuzen
												updateNumberprotokollVorlage('ID');
											});
											} else {
												// gesamten Tab ersetzen
												var tab = $("#protokollVorlage-table");
												tab.children().remove();
												el = tab.html('<div class="fop-lazy-reload" onclick="reloadprotokollVorlage()"></div>');
											}
											<?php } ?>
											
										}
									}
									function checkprotokollVorlage (id, col, checked) {
										// ID-Liste aufbauen
										if (!window.DataViewChecked) window.DataViewChecked = {};
										if (!window.DataViewChecked['protokollVorlage']) window.DataViewChecked['protokollVorlage'] = {};
										if (!window.DataViewChecked['protokollVorlage'][col]) window.DataViewChecked['protokollVorlage'][col] = new IDList();

										// Abfrage aller gecheckten IDs für eine Tabelle
										if (!id) {
											return window.DataViewChecked['protokollVorlage'][col].toString();
										}

										// check all, check id
										if (id == 'all') {
											// TODO: umbauen #1289: 'all' auch nur auf ne idlist reduzieren
											if (checked) {
												$.get(reloadprotokollVorlage({action: 'getids', col: col}, true), function (ids) {
													window.DataViewChecked['protokollVorlage'][col] = new IDList(ids);
													updateNumberprotokollVorlage(col);
												});
											} else {
												window.DataViewChecked['protokollVorlage'][col] = new IDList();
												updateNumberprotokollVorlage(col);
											}
										} else {
											var ids = new IDList(id);
											var allcb = $('#protokollVorlage__all-checkbox');
											if (allcb[0]) {
												allcb[0].parentElement.MaterialCheckbox.uncheck(); // TODO: prüfen, ob Gruppen-CBs voll werden
											}
											if (checked == 'set') {
												window.DataViewChecked['protokollVorlage'][col] = ids;
											} else for (id of ids.all()) {
												if (checked) {
													window.DataViewChecked['protokollVorlage'][col].push(id);
												} else {
													window.DataViewChecked['protokollVorlage'][col].remove(id);
												}
											}
											updateNumberprotokollVorlage(col);
										}
									}
								</script><?php

    
  }

  public static function renderSpecialFilters() { 
    
    
    // --- BLOCK: main ---
    ?>
	
	<script type"text/javascript">
		function updateSpecialFilter(param, val) {
			query[param] = val.toString();reloadprotokollVorlage();
			
		}

	</script>
	<?php
	
    
  }

  public static function renderTabTableAction() { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
     ?><div class='fop-dv-buttonbar'><?php if((!\FOP\User::getIsGuest())) { ?><a class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored" onclick="
		var self = this;
		event.preventDefault();
		$.get(reloadprotokollVorlage({action: 'open', fop_table: 'protokollVorlage', fop_id: '_', fop_from: location.href}, true))
		.then(function () {
			window.open_url(self.href, false);
		});" href="<?php echo htmlentities(\TablesRouter\ProtokollVorlage::createURL2(['from' => $_GET['from'] ?? null, 'popup' => $_GET['popup'] ?? null])); ?>"><i class="material-icons">add</i> <?php echo(sprintf(_('create %s'), _('Protokoll-Vorlage'))); ?></a><?php } ?></div><?php 
								\FOP\User::getIsGuest();
								$itemheight = 32;
								$itemsperpage = ceil(1080 / $itemheight * 0.8);
								$page = (isset($_GET['page_protokollVorlage']) ? intval($_GET['page_protokollVorlage']) : 0);
								$addlines = (isset($_GET['addlines_protokollVorlage']) ? intval($_GET['addlines_protokollVorlage']) : 0);
								$firstitem = $page * $itemsperpage;
								$sqladdon = ' LIMIT ' . ($itemsperpage * 2) . ' OFFSET ' . ($firstitem);
								$data = self::getData($sqladdon, $_GET);
								$arr = $data["items"];
								$itemcount = $data["itemcount"];
								$lastPage = ceil($itemcount/$itemsperpage-1);
								// calculate width of first column: 67px + 32px for each shortcut
								$firstColumnWidth = 66 + 34 + 34 + 34;
								$additionalLines = 0;

									// Spaltenliste zuerst aufbauen, damit sie noch umsortiert werden kann
									$order = 1000;
									$columns = [];
									
										if(true){
											$col = [
												'id' => 'title',
												'desc' => _('Titel'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['title'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'content',
												'desc' => _('Inhalt'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['content'] = $col;
										}
									

									// gespeicherte Spaltenanordnung
									foreach (\FOP\Database::query('SELECT * FROM fop_dataview WHERE '.qi('user').' = ' . \FOP\Database::quote(\FOP\User::getID()) . ' AND dataview = ' . \FOP\Database::quote('protokollVorlage'))->fetchAll(\PDO::FETCH_ASSOC) AS $column => $c) {
										if (isset($columns[$c['column']])) {
											$columns[$c['column']]['order'] = $c['order']; // order, width, collapsed
											$columns[$c['column']]['width'] = $c['width']; // order, width, collapsed
											$columns[$c['column']]['collapsed'] = $c['collapsed']; // order, width, collapsed
										}
									}

									// DOM vor-rendern
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='title'
												data-order='<?php echo intval($columns['title']['order']); ?>'
												data-width='<?php echo intval($columns['title']['width']); ?>'
												data-collapsed='<?php echo intval($columns['title']['collapsed']); ?>'
												style='width: <?php echo intval($columns['title']['width']); ?>px; <?php if ($columns['title']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadprotokollVorlage(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_protokollVorlage_title'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_protokollVorlage_title'] = text.val(); } else { delete query['search_protokollVorlage_title']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_protokollVorlage').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_protokollVorlage_title'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_protokollVorlage_title'] = text2.val(); } else { delete query['searchnot_protokollVorlage_title']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_protokollVorlage').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_protokollVorlage'] == 'title ASC') {
			query['sort_protokollVorlage'] = 'title DESC';
		 } else if (query['sort_protokollVorlage'] == 'title DESC') {
		 	delete query['sort_protokollVorlage'];
		 } else {
			query['sort_protokollVorlage'] = 'title ASC';
		 }
		 reloadprotokollVorlage();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Titel')); ?>'><?php echo(_('Titel')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_protokollVorlage']) && $_GET['sort_protokollVorlage'] == 'title ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_protokollVorlage']) && $_GET['sort_protokollVorlage'] == 'title DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_protokollVorlage_title']) || isset($_GET['range_max_protokollVorlage_title']) || isset($_GET['deps_protokollVorlage_title']) || isset($_GET['fullsearch_protokollVorlage_title']) || isset($_GET['dynamic_protokollVorlage_title']) || isset($_GET['search_protokollVorlage_title']) || isset($_GET['searchnot_protokollVorlage_title']) || isset($_GET['filter_protokollVorlage_title'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['title']['header'] = ob_get_contents(); ob_end_clean();
											$columns['title']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['title']['width']); ?>px; <?php if ($columns['title']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='title'><span class='overflow-text' title="<?php echo htmlentities($item['title']); ?>"><?php echo htmlentities($item['title']); ?></span></div><?php
											};
											$columns['title']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='title'
													data-order='<?php echo intval($columns['title']['order']); ?>'
													data-width='<?php echo intval($columns['title']['width']); ?>'
													data-collapsed='<?php echo intval($columns['title']['collapsed']); ?>'
													style='width: <?php echo intval($columns['title']['width']); ?>px; <?php if ($columns['title']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='content'
												data-order='<?php echo intval($columns['content']['order']); ?>'
												data-width='<?php echo intval($columns['content']['width']); ?>'
												data-collapsed='<?php echo intval($columns['content']['collapsed']); ?>'
												style='width: <?php echo intval($columns['content']['width']); ?>px; <?php if ($columns['content']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadprotokollVorlage(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_protokollVorlage_content'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_protokollVorlage_content'] = text.val(); } else { delete query['search_protokollVorlage_content']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_protokollVorlage').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_protokollVorlage_content'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_protokollVorlage_content'] = text2.val(); } else { delete query['searchnot_protokollVorlage_content']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_protokollVorlage').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_protokollVorlage'] == 'content ASC') {
			query['sort_protokollVorlage'] = 'content DESC';
		 } else if (query['sort_protokollVorlage'] == 'content DESC') {
		 	delete query['sort_protokollVorlage'];
		 } else {
			query['sort_protokollVorlage'] = 'content ASC';
		 }
		 reloadprotokollVorlage();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Inhalt')); ?>'><?php echo(_('Inhalt')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_protokollVorlage']) && $_GET['sort_protokollVorlage'] == 'content ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_protokollVorlage']) && $_GET['sort_protokollVorlage'] == 'content DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_protokollVorlage_content']) || isset($_GET['range_max_protokollVorlage_content']) || isset($_GET['deps_protokollVorlage_content']) || isset($_GET['fullsearch_protokollVorlage_content']) || isset($_GET['dynamic_protokollVorlage_content']) || isset($_GET['search_protokollVorlage_content']) || isset($_GET['searchnot_protokollVorlage_content']) || isset($_GET['filter_protokollVorlage_content'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['content']['header'] = ob_get_contents(); ob_end_clean();
											$columns['content']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['content']['width']); ?>px; <?php if ($columns['content']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='content'><?php 
	$html = preg_replace('/^<!DOCTYPE.+?>/m', '', \FOP\Sanitizers::htmlentities_decode($item['content'])); ?>
	<span style="display: block;" onmouseenter='handleHTMLOverlay(event, &apos;#overlayFormcontent<?php echo htmlentities($item['ID'] ?? 'fail'); ?>&apos;);' onmouseleave='handleHTMLOverlayFade(event, &apos;#overlayFormcontent<?php echo htmlentities($item['ID'] ?? 'fail'); ?>&apos;);' ng-non-bindable><?php echo htmlentities(mb_substr(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($item['content'])))), 0, 50) . (strlen(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($item['content']))))) >= 50 ? '...' : ''));  ?></span>
	<div class="overlay-iframe" id="overlayFormcontent<?php echo $item['ID'] ?? 'fail'; ?>">
		<div class="iframe-container" id="iframecontainer">
			<?php echo \FOP\Util::SanitizeUserHtml($html); ?>
		</div>
	</div>
</div><?php
											};
											$columns['content']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='content'
													data-order='<?php echo intval($columns['content']['order']); ?>'
													data-width='<?php echo intval($columns['content']['width']); ?>'
													data-collapsed='<?php echo intval($columns['content']['collapsed']); ?>'
													style='width: <?php echo intval($columns['content']['width']); ?>px; <?php if ($columns['content']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									

									// sort by order
									uasort($columns, function ($a, $b) {
										return $a['order'] - $b['order'];
									});
									?>
									<style type='text/css'>
										#protokollVorlage-table .fop-table-header {
											height: <?php echo 32; ?>px;
										}
										#protokollVorlage-table .fop-table-header .fop-table-column .title,
										#protokollVorlage-table .fop-column-handle,
										#protokollVorlage-table .fop-table-row,
										#protokollVorlage-table .fop-table-row .fop-table-column,
										#protokollVorlage-table .fop-table-column-multicontrol,
										#protokollVorlage-table .fop-filter-button {
											height: 32px;
											line-height: 32px;
										}
										</style>
											<div class="fop-table" data-table-id="protokollVorlage">
											<div class="fop-legend"></div>
											<div class="fop-filter-string-wrapper"><div class="fop-filter-string"><label>Filter:</label> <span><?php echo self::getFilterHTML($_GET); ?></span></div></div>
											
											<?php if (isset($_GET['select'])) { echo '<br>'; } ?>
											<div class="fop-table-header">
											<?php if (!isset($_GET['select'])) { ?>
												<div class="fop-table-column noprint" style="width: <?php echo json_encode($firstColumnWidth); ?>px;">
													
													<div class="fop-table-column-multicontrol">
													<label class="mdl-checkbox mdl-js-checkbox"  style='width: auto;' for="protokollVorlage__all-checkbox">
														<input class="mdl-checkbox__input" id="protokollVorlage__all-checkbox" type="checkbox" onchange="checkprotokollVorlage('all', 'ID', this.checked);">
														</label>
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon protokollVorlage__mass-action" style='visibility: hidden;' onclick="$.get('DataView/ProtokollVorlage/permissions?id=' + checkprotokollVorlage(null, 'ID'), function (data) { for (var method in data) if (method != '__cnt') { var btn = $('[data-interaction-name=&quot;' + method + '&quot;]'); if (data[method] >= 1) btn.show(); else btn.hide(); btn.find('.cnt').text(data[method]); }; }); dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">more_vert</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterall" style="margin-right:auto; text-align:left;"
					onclick="for (key in query) if (key.indexOf('range_min_protokollVorlage_') == 0 || key.indexOf('range_max_protokollVorlage_') == 0 || key.indexOf('deps_protokollVorlage_') == 0 || key.indexOf('fullsearch_protokollVorlage_') == 0 || key.indexOf('dynamic_protokollVorlage_') == 0 || key.indexOf('search_protokollVorlage_') == 0 || key.indexOf('searchnot_protokollVorlage_') == 0 || key.indexOf('filter_protokollVorlage_') == 0) delete query[key]; reloadprotokollVorlage(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">list</i></span><span class="fop-menu-caption" title="<?php echo(_('view all elements')); ?>"><?php echo(_('view all elements')); ?> 
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filteronly" style="margin-right:auto; text-align:left;"
					onclick="query['filter_protokollVorlage_ID'] = checkprotokollVorlage(null, 'ID'); delete query['page_protokollVorlage']; reloadprotokollVorlage(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">arrow_forward</i></span><span class="fop-menu-caption" title="<?php echo(_('view only these elements')); ?>"><?php echo(_('view only these elements')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterrange" style="margin-right:auto; text-align:left;"
					onclick="
		var ticks = new IDList(checkprotokollVorlage(null, 'ID'));
		var range = prompt('Bitte geben Sie den Bereich ein', '1-' + ticks.count());
		var newticks = new IDList();
		if (range) {
			range = range.split('-');
			if (range.length == 1) {
				range.push(range[0]);
			}
			var skip = (range[0] || 1) - 1;
			var take = (range[1] || Infinity) - skip;
			for (var item of ticks.all()) {
				if (skip > 0) {
					skip--;
				} else if (take > 0) {
					newticks.push(item);
					take--;
				} else break;
			}
			checkprotokollVorlage(newticks, 'ID', 'set');
		} $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">colorize</i></span><span class="fop-menu-caption" title="<?php echo(_('limit range')); ?>"><?php echo(_('limit range')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true && (!\FOP\User::getIsGuest())) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;"
					onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return;$.get('Tables/ProtokollVorlage/delete?ajax&from=<?php echo urlencode(\FOP\Util::getBackUrl()); ?>&id=' + escape(checkprotokollVorlage(null, 'ID'))).then(function () { reloadprotokollVorlage(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?>
														</ul>
														<!-- column hide -->
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon" onclick="dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">visibility</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php foreach ($columns AS $col) { ?>
																<li class="mdl-list__item mdl-button" onclick="
																	var isVisible = this.firstElementChild.innerText !== 'clear';
																	this.firstElementChild.innerText = isVisible ? 'clear' : 'visibility'; // switch icon
																	tableColumnVisibility('protokollVorlage', <?php echo htmlentities(json_encode($col['id'])); ?>, !isVisible); // the rest is up to a helper function in layout/tables.fop
																	">
																	<i class="material-icons"><?php if ($col['collapsed']) { echo 'clear'; } else { echo 'visibility'; }?></i>
																	<?php echo htmlentities($col['desc']); ?>
																</li>
															<?php } ?>
															<li class="mdl-list__item mdl-button" onclick="
																$.get('FOP/Index/dataview?data='+encodeURIComponent(JSON.stringify({dataview: 'protokollVorlage', reset: true}))).then(function () { location.reload(); });
																">
																<i class="material-icons">refresh</i>
																<?php echo _('reset all'); ?>
															</li>
														</ul>
													</div>
												</div><?php }
												
												foreach ($columns AS $col) {
													// Spalten-Überschrift rendern
													echo $col['header'];
												} ?>
											 </div>
											
											<div class="fop-table-body" id="table_protokollVorlage" <?php \EasyEditor\Navigation::printScroll('dv.ProtokollVorlage', '/* scroll horiz */ this.previousElementSibling.firstElementChild.style.marginLeft = \'-\' + this.scrollLeft + \'px\';
												/* scroll verti */
												var self = this;
												if (window.DataViewScrollReloadTimeout) clearTimeout(window.DataViewScrollReloadTimeout);
												window.DataViewScrollReloadTimeout = setTimeout(function () {
													var currentPage = parseInt(query[\'page_protokollVorlage\'] || 0);
													var paddingTop = parseInt( self.lastElementChild.style.paddingTop, 10);
													var wantedPage = Math.max(0, currentPage + Math.floor((self.scrollTop - paddingTop) / ' . ($itemheight * $itemsperpage) . '));
													if (wantedPage != currentPage) {
														query[\'page_protokollVorlage\'] = wantedPage;
														reloadprotokollVorlage(undefined, undefined, true);
													}
												}, 50);
											'); ?>>
												<div class="fop-table-body-inner" style="min-height: <?php echo 12 + $itemheight * ($itemcount + $additionalLines); ?>px; padding-top: <?php echo $itemheight * $itemsperpage * $page; ?>px;">
												<?php foreach($arr as $itempos => $item) {
													?>
													<div class="fop-table-row" style=""data-itempos="<?php echo htmlentities($item['sortableOrder']); ?>" data-protokollVorlage-id="<?php echo htmlentities($item['ID']); ?>"<?php if (isset($item['ID'])){
														if (isset($_GET['select']) && isset($_GET['from'])) {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) window.location.href=' . htmlentities(json_encode($_GET['from'] . '&colvalue=' . urlencode($item['ID']))) . ';" ';
														} else {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) open_url(reloadprotokollVorlage({action: \'open\', fop_table: \'protokollVorlage\', fop_id: ' .  htmlentities(json_encode($item['ID'])) . ', fop_from: location.href}, true), false);"';
														}
													}?> >

													<?php if (!isset($_GET['select'])) { ?>
													<div class='fop-table-column noprint' style="width: <?php echo json_encode($firstColumnWidth); ?>px;" onclick="$(this).find('input[type=checkbox]').first().click(); event.stopPropagation();">
													<label onclick="event.stopPropagation();" class="mdl-checkbox mdl-js-checkbox protokollVorlage__checkbox protokollVorlage__checkbox protokollVorlage__checkbox-ID-<?php echo htmlentities($item['ID']); ?>" style="width: auto;" for="protokollVorlage__<?php echo htmlentities($itempos); ?>-checkbox">
													<input class="mdl-checkbox__input" id="protokollVorlage__<?php echo htmlentities($itempos); ?>-checkbox" type="checkbox" onchange="<?php if (isset($item['ID'])) echo 'checkprotokollVorlage(' . htmlentities(json_encode($item['ID'])) . ', \'ID\', this.checked); ' ?>">
													</label><?php if(!isset($item['canSort']) || $item['canSort']) {
														?><a title="<?php echo htmlentities(_('sort')); ?>" class="sorthandle mdl-button mdl-js-button mdl-button--icon" onclick="event.stopPropagation();"><i class="material-icons">swap_vert</i></a><?php
													} ?><button type="button" class="mdl-button mdl-js-button mdl-button--icon protokollVorlage__action" onclick="
														event.stopPropagation();
														dropDownFixPosition($(this), $(this).next());
														">
														<i class="material-icons">more_vert</i>
													</button><ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu" id="fop-scroll-menu-protokollVorlage-action-<?php echo $item['ID'] ?? 0; ?>">
														<?php
		if(isset($item['ID']) && $item['operation::view']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="view" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\ProtokollVorlage::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick=" if (!event.ctrlKey) { open_url(reloadprotokollVorlage({action: 'open', fop_table: 'protokollVorlage', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; } $(this).closest('.overlay').click(); return false;  
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">find_in_page</i></span><span class="fop-menu-caption" title="<?php echo(_('open')); ?>"><?php echo(_('open')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="edit" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\ProtokollVorlage::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">edit</i></span><span class="fop-menu-caption" title="<?php echo(_('edit')); ?>"><?php echo(_('edit')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::delete']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;" href="#"
				onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return false;   $.get('Tables/ProtokollVorlage/delete?ajax&id=<?php echo htmlentities($item['ID']);?>&from=<?php echo htmlentities(\FOP\Util::getBackUrl());?>').then(function () { reloadprotokollVorlage(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?></span>
			</a>
		<?php } ?>
													</ul><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="protokollVorlage" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="edit" href="<?php echo htmlentities(\TablesRouter\ProtokollVorlage::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadprotokollVorlage();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('edit')); ?>">
				<i class="material-icons">edit</i>
			</a><?php } ?><?php
		if(isset($item['ID']) && $item['operation::view']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="protokollVorlage" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="view" href="<?php echo htmlentities(\TablesRouter\ProtokollVorlage::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();  if (!event.ctrlKey) { open_url(reloadprotokollVorlage({action: 'open', fop_table: 'protokollVorlage', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; }  reloadprotokollVorlage();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('open')); ?>">
				<i class="material-icons">find_in_page</i>
			</a><?php } ?>
													</div><?php } ?><?php
													
													foreach ($columns AS $col) {
														$col['render']($item);
													}
													?></div>
												 <?php }?>

													</div>
												</div>

												
												
												<script src='js/jquery.ui.touch-punch.min.js'></script>
												<script type="text/javascript">
												$(function(){
													$("#table_protokollVorlage .fop-table-body-inner").sortable({
														'cursor': 'move',
														'handle': '.sorthandle',
														'start': function (event, ui) {
														},
														'update': function (event, ui) {
															var newids = $("#table_protokollVorlage .fop-table-body-inner").sortable("toArray", {"attribute": "data-protokollVorlage-id"});
															var positions = $("#table_protokollVorlage .fop-table-body-inner").sortable("toArray", {"attribute": "data-itempos"}).map(function (x) {
																if (!x || x == 0) {
																	// nullen sanitizen
																	x = Math.round(Math.random() * 2000000) + 100;
																}
																return x;
															});
															positions.sort(function (a, b) {
																return Number(a) - Number(b);
															}); // sortieren, damit die neue Reihenfolge funzt
															var changedpos = {};
															for(var i = 0; i < newids.length; i++){
																changedpos[newids[i]] = positions[i]; 
															}
															
															$.get(reloadprotokollVorlage({action: "sort", data: JSON.stringify(changedpos)}, true), function(response){
																// OK
															});
														}
													});
												});
												</script>
												
												</div><?php
												
	
    
  }

  public static function getidsAction($col) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
			$q = \FOP\Database::query('SELECT t.'.qi($col).' '.self::getSQL($_GET));
			$result = new \FOP\IDList();
			while ($item = $q->fetchColumn()) {
				$result->push($item);
			}
			die($result->toString());

    
  }

  public static function permissionsAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		$ids = new \FOP\IDList($id);
		header('Content-Type: application/json');
		
		$perms = \FOP\Database::query('SELECT COUNT(*) AS __cnt, SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filteronly').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterrange').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterall').', SUM(CASE ('.(\FOP\User::getIsGuest() ? 'false' : 'true').') WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('delete').' FROM '.qi('protokollVorlage').' WHERE ' . $ids->toSQL(qi('ID')))->fetch(\PDO::FETCH_ASSOC);
		
		return $perms;
	
    
  }

  public static function sortAction($data) { 
    
    
    // --- BLOCK: access ---
    if(!((!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest()))) throw new \FOP\AccessDeniedException();
    // --- BLOCK: main ---
    
		if ($data == '*') {
			// Position aus sord_protokollVorlage ziehen
			$q = self::getData(' LIMIT 1024', $_GET, true);
			$order = 1;
			$s = [];
			foreach ($q AS $item) {
				array_push($s, 'WHEN ' . intval($item['ID']) . ' THEN ' . intval($order++));
			}
		} else {
			// Position von Elementen als JSON aus $data ziehen
			$newpos = json_decode($data, true);

			$s = array_map(function($value, $key){
				return 'WHEN ' . intval($key) . ' THEN ' . intval($value);
			}, array_values($newpos), array_keys($newpos));
		}

		// Zugriffsregel: sort
		$sql = 'UPDATE '.qi('protokollVorlage').' SET '.qi('sortableOrder').' = (CASE '.qi('ID').' ' . implode(' ', $s) . ' ELSE '.qi('sortableOrder').' END) WHERE ('.(\FOP\User::getIsGuest() ? 'false' : 'true').')';

		\FOP\Database::query($sql);

		
	
    
  }

  public static function getSQL($params) { 
    
    
    // --- BLOCK: main ---
    
								// returns a sql snippet 'FROM (...) AS t WHERE' where you can prepend your select clauses and append your ORDER LIMIT
								$sql = 'FROM (SELECT /* ID */ '.qi('ID').' AS '.qi('ID').',
									/* canSort */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('canSort').',
									/* content */ '.qi('content').' AS '.qi('content').',
									/* operation::create */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::create').',
									/* operation::delete */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::delete').',
									/* operation::edit */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::edit').',
									/* operation::index */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::index').',
									/* operation::view */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::view').',
									/* sortableOrder */ '.qi('sortableOrder').' AS '.qi('sortableOrder').',
									/* title */ '.qi('title').' AS '.qi('title').',
									1
								FROM '.qi('protokollVorlage').' '.qi('protokollVorlage').'
								WHERE (('.(\FOP\User::getIsGuest() ? 'false' : 'true').'))) AS t
								WHERE ' . (isset($params['filter_protokollVorlage_title']) ? ($params['filter_protokollVorlage_title'] !== '' ? ('(' . (new \FOP\IDList($params['filter_protokollVorlage_title']))->toSQL('t.'.qi('title').'') . ') AND ') : '') : '') . 
								(isset($params['filter_protokollVorlage_content']) ? ($params['filter_protokollVorlage_content'] !== '' ? ('(' . (new \FOP\IDList($params['filter_protokollVorlage_content']))->toSQL('t.'.qi('content').'') . ') AND ') : '') : '') . 
								(isset($params['filter_protokollVorlage_ID']) ? ($params['filter_protokollVorlage_ID'] !== '' ? ('(' . (new \FOP\IDList($params['filter_protokollVorlage_ID']))->toSQL('t.'.qi('ID').'') . ') AND ') : '') : '') . 
								(isset($params['search_protokollVorlage_title']) ? 't.'.qi('title').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_protokollVorlage_title'] . '%') . ' AND ' : '') . 
								(isset($params['search_protokollVorlage_content']) ? 't.'.qi('content').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_protokollVorlage_content'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_protokollVorlage_title']) ? 'NOT t.'.qi('title').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_protokollVorlage_title'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_protokollVorlage_content']) ? 'NOT t.'.qi('content').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_protokollVorlage_content'] . '%') . ' AND ' : '') . 
								(isset($params['search_protokollVorlage']) ? '(' . 't.'.qi('title').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_protokollVorlage'] . '%') . ' OR ' . 't.'.qi('content').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_protokollVorlage'] . '%') . ') AND ' : '') . 
								'
								 TRUE ';
								return $sql;
	
    
  }

  public static function getData($sqladdon, $params, $stream = false ) { 
    
    
    // --- BLOCK: main ---
    
								$sql = self::getSQL($params);

								$order = (\FOP\Util::array_value(array(
									'content ASC' => 'ORDER BY t.'.qi('content').' ASC',
									'title ASC' => 'ORDER BY t.'.qi('title').' ASC',
									'content DESC' => 'ORDER BY t.'.qi('content').' DESC',
									'title DESC' => 'ORDER BY t.'.qi('title').' DESC',
									'' => ''), isset($params['sort_protokollVorlage']) ? $params['sort_protokollVorlage'] : '') ?: 'ORDER BY '.qi('t').'.'.qi('sortableOrder').' ');
								// wenn sqladdon bereits ein ORDER enthält, kein order aufbauen
								if (strpos($sqladdon, 'ORDER') !== false) {
									$order = '';
								}
								if ($stream) {
									// als Stream (währenddessen darf keine weitere SQL-Query laufen) für große Datenmengen und Statistiken
									$result = (function () use ($sql, $order, $sqladdon) {
										$stream = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
										while ($item = $stream->fetch(\PDO::FETCH_ASSOC)) {
											
											yield $item;
										}
									})();
								} else {
									// als RAM-Array
									$result = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
									$arr = $result->fetchAll(\PDO::FETCH_ASSOC);
									$itemcount = count($arr);

									foreach($arr as $i => &$item){
										
									}
									unset($item);

									$result = ["items" => $arr, "itemcount" => $itemcount];

									
								}

								return $result;
	
    
  }

  public static function getFilterHTML($params, $delimiter = ', ' , $showButton = true ) { 
    
    
    // --- BLOCK: main ---
    
		// Contract: ist showButton == false, sollten keine HTML-Tags im Output enthalten sein (Verwendung in Dateinamen!!)
		$filters = [];
		if (isset($params['filter_protokollVorlage_title'])) {
		if ($params['filter_protokollVorlage_title'] == '_null') {
			array_push($filters, _('Titel') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_protokollVorlage_title']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Titel') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_protokollVorlage_content'])) {
		if ($params['filter_protokollVorlage_content'] == '_null') {
			array_push($filters, _('Inhalt') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_protokollVorlage_content']))->all() AS $val) {
				$value = mb_substr(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($val)))), 0, 20) . (strlen($val) >= 20 ? '...' : '');
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Inhalt') . ': ' . implode(', ', $values));
		}
	}if (isset($params['search_protokollVorlage_title'])) {
		array_push($filters, _('title') . ' ' . _('filter_contains') . ' ' . $params['search_protokollVorlage_title']);
	}if (isset($params['search_protokollVorlage_content'])) {
		array_push($filters, _('content') . ' ' . _('filter_contains') . ' ' . $params['search_protokollVorlage_content']);
	}if (isset($params['searchnot_protokollVorlage_title'])) {
		array_push($filters, _('title') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_protokollVorlage_title']);
	}if (isset($params['searchnot_protokollVorlage_content'])) {
		array_push($filters, _('content') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_protokollVorlage_content']);
	}
		if (isset($params['sort_protokollVorlage']) && $showButton) {
			array_push($filters, [htmlentities(_('sort order')), ' <i class="material-icons fop-small" style="cursor: pointer;" onclick="$.get(reloadprotokollVorlage({action: &apos;sort&apos;, data: &apos;*&apos;}, true)).then(function () { delete query[&apos;sort_protokollVorlage&apos;]; reloadprotokollVorlage();  });">💾</i>']);
		}
	
		if (count($filters)) {
			$result = implode($delimiter, array_map(function ($filter) {
				if (is_array($filter)) {
					return implode('', $filter);
				}
				return htmlentities($filter);
			}, $filters))
			// Button, um Filter zu entfernen
			. ($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="for (var q in query) {if (q.includes(\'_protokollVorlage_\')) delete query[q];} reloadprotokollVorlage(); ">clear</i>' : '');
		} else {
			$result = _('no_filter');
		}
		return $result;
	
    
  }

  public static function openAction($fop_table, $fop_id, $fop_from) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    

if ($fop_table == 'protokollVorlage') {
	\FOP\Session::setPayload('dv-protokollVorlage', [
		'id' => 'protokollVorlage',
		'tbl' => 'protokollVorlage',
		'idcol' => 'ID',
		'prev' => \DataViewRouter\ProtokollVorlage::stepURL('protokollVorlage', 'XXX', -1),
		'next' => \DataViewRouter\ProtokollVorlage::stepURL('protokollVorlage', 'XXX',  1),
		'from' => $fop_from
	]);
	
	if ($fop_id == '_') return; // nur Rückreferenz setzen, nicht öffnen
	$params = [];
	if (isset($_GET['popup'])) $params['popup'] = true;
	if (isset($_GET['from'])) $params['from'] = $_GET['from'];
	$params['id'] = $fop_id;
	
	$url = \TablesRouter\ProtokollVorlage::viewURL2($params);
	header('Location: ' . $url);
}

die();
    
  }

  public static function stepAction($tbl, $id, $step) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
	$dv = \FOP\Session::getPayload('dv-'.$tbl);
	$url = $dv['from'];
	$parts = parse_url($url);
	parse_str($parts['query'], $query);
	$data = self::getData('', $query);
	$col = $dv['idcol'];
	$ids = array_map(function ($x) use ($col) {return $x[$col];}, $data['items']);
	if (!count($ids)) {
		header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])));
		die();
	}
	$idx = array_search($id, $ids);
	$idx += count($ids) + $step;
	$idx = $idx % count($ids);
	header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])) . '/view?id=' . urlencode($ids[$idx]));
	die();

    
  }


  
  

  
  
}



